AIR
==============================

AIR is an open-source machine-learning project that aims to model and find patterns in health care data.

Project Organization
==============================

    ├── LICENSE
    ├── Makefile           <- Makefile with commands like `make data` or `make train`
    ├── README.md          <- The top-level README for developers using this project.
    ├── data
    │   ├── external       <- Data from third party sources.
    │   ├── interim        <- Intermediate data that has been transformed.
    │   ├── processed      <- The final, canonical data sets for modeling.
    │   └── raw            <- The original, immutable data dump.
    │
    ├── docs               <- A default Sphinx project; see sphinx-doc.org for details
    │
    ├── models             <- Trained and serialized models, model predictions, or model summaries
    │
    ├── notebooks          <- Jupyter notebooks. Naming convention is a number (for ordering),
    │                         the creator's initials, and a short `-` delimited description, e.g.
    │                         `1.0-jqp-initial-data-exploration`.
    │
    ├── references         <- Data dictionaries, manuals, and all other explanatory materials.
    │
    ├── reports            <- Generated analysis as HTML, PDF, LaTeX, etc.
    │ 
    ├── requirements.txt   <- The requirements file for reproducing the analysis environment, e.g.
    │                         generated with `pip freeze > requirements.txt`
    │
    ├── setup.py           <- makes project pip installable (pip install -e .) so src can be imported
    ├── src                <- Source code for use in this project.
    └── tox.ini            <- tox file with settings for running tox; see tox.readthedocs.io

Requirements
==============================
Python == 3.8

Usage
==============================

To get up and running, clone the repository and copy the raw data to `air\data\raw\2020` or `air\data\raw\2019`, depending on your data version. Then go to do root project directory, install all modules and then install all requirements as follows:

    $ pip install -e .
    $ pip install -r requirements.txt

In the root project directory there is a client which can create datasets, make models and generate SHAP plots. It's a executable Python script. By default it will use the 2020 data version, encode the datasets as embeddings, not make visuzaliations of embeddings and not use the real ATS names, but their ISO id instead. To run the client:

    $ python .\client.py -h

As an example, to run the client with the 2020 data version and with embeddings:


    $ python .\client.py --dataset-year '2020' --dataset-version 'emb'

Contact
==============================

Please contact [Christian Marius Lillelund](mailto:cl@ece.au.dk) for questions regarding this repository.
