export class Hmi {
    private $_first: string
    private $_second: string
    private $_third: string
    private $_fourth: string
    private $_fith: string

    private $_name: string

    constructor(hmiNumber: string) {
        this.$_first = hmiNumber.substring(0, 2)
        this.$_second = hmiNumber.substring(2, 4)
        this.$_third = hmiNumber.substring(4, 6)
        this.$_fourth = hmiNumber.substring(6, 8)
        this.$_fith = hmiNumber.substring(8, 10)

        this.$_name = this.nameMapper()
    }

    get HmiNumber(): string {
        return `${this.$_first}${this.$_second}${this.$_third}${this.$_fourth}${this.$_fith}`;
    }

    get HmiClassification() {
        return `${this.$_first}${this.$_second}${this.$_third}`
    }

    get HmiName(): string {
        return this.$_name;
    }

    private nameMapper() {
        switch (this.$_first) {
            case '22':
                switch (this.$_second) {
                    case '27':
                        switch (this.$_third) {
                            case '18':
                                switch (this.$_fourth) {
                                    case '10':
                                        break
                                    default:
                                        return 'Personlige nødalarmsystemer'
                                }
                                break
                            default:
                                return 'Hjælpemidler til signalering, identificering, varsling, overvågning, tidsangivelse, planlægning og erindring'
                        }
                        break
                    default:
                        return 'Hjælpemidler til håndtering af kommunikation og information'
                }
                break
            case '12':
                switch (this.$_second) {
                    case '03':
                        switch (this.$_third) {
                            case '06':
                                return 'Albuestokke'
                                break
                            default:
                                return 'Ganghjælpemidler, som håndteres med en arm'
                        }
                        break
                    case '06':
                        switch (this.$_third) {
                            case '06':
                                return 'Rollatorer'
                                break
                            default:
                                return 'Ganghjælpemidler, som håndteres med begge arme'
                        }
                        break
                    case '31':
                        switch (this.$_third) {
                            case '03':
                                return 'Glide- og vendehjælpemidler'
                                break
                            default:
                                return 'Hjælpemidler til at skifte stilling'
                        }
                        break
                    default:
                        return 'Hjælpemidler til personlig mobilitet og transport'
                }
                break
            case '09':
                switch (this.$_second) {
                    case '12':
                        switch (this.$_third) {
                            case '18':
                                return 'Toiletforhøjere, fastmonterede'
                                break
                            default:
                                return 'jælpemidler til toiletbesøg'
                        }
                        break
                    case '33':
                        switch (this.$_third) {
                            case '07':
                                return 'Bade- og brusestole med og uden hjul'
                                break
                            default:
                                return 'Hjælpemidler til vask, bad og brusning'
                        }
                        break
                    default:
                        return 'Hjælpemidler til personlig pleje'
                }
                break
            case '24':
                switch (this.$_second) {
                    case '21':
                        switch (this.$_third) {
                            case '03':
                                return 'Gribetænger, manuelle'
                                break
                            default:
                                return 'Hjælpemidler til udvidet rækkeevne'
                        }
                        break
                    default:
                        return 'Hjælpemidler til at betjene, bære, flytte og håndtere genstande og udstyr'
                }
                break
            default:
                return 'blabla'
            // throw new Error('not implemented')
        }
        return "";
    }

}
